//
//  main.cpp
//  Loader
//
//  Created by Johannes Schröter on 18.01.13.
//  Copyright (c) 2013 devwerks.net. All rights reserved.
//

#include <stdio.h>
#include <security/Authorization.h>
#include <security/AuthorizationDB.h>
#include <security/AuthorizationTags.h>

int main(int argc, const char * argv[])
{
    char cwd[1024];
    char * szToolPath;
    AuthorizationRef authorization;
    
    OSStatus status = AuthorizationCreate ( NULL, kAuthorizationEmptyEnvironment, kAuthorizationFlagDefaults, &authorization );
    
    if ( status != 0 )
    {
        return -1;
    }
    
    AuthorizationItem   myItems  = { kAuthorizationRightExecute, 0, NULL, 0 };
    AuthorizationRights myRights = { 1, &myItems };
    AuthorizationFlags  myFlags  = kAuthorizationFlagInteractionAllowed | kAuthorizationFlagPreAuthorize | kAuthorizationFlagExtendRights;
    
    status = AuthorizationCopyRights ( authorization, &myRights, kAuthorizationEmptyEnvironment, myFlags, NULL );
    
    if ( status != 0 )
    {
        return -1;
    }
    
    szToolPath = getcwd(cwd, sizeof(cwd));
    strcat( szToolPath, "/start_as_root_example.app/Contents/MacOS/start_as_root_example" );
    
    status = AuthorizationExecuteWithPrivileges ( authorization, szToolPath, kAuthorizationFlagDefaults, NULL, NULL );
    status = AuthorizationFree ( authorization, kAuthorizationFlagDestroyRights );
    
    return 0;
}

